/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ActivitiesGrowthCount type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ActivitiesGrowthCount{}

// ActivitiesGrowthCount struct for ActivitiesGrowthCount
type ActivitiesGrowthCount struct {
	MessengerMoment *GrowthCount `json:"messengerMoment,omitempty"`
	Visit *GrowthCount `json:"visit,omitempty"`
	Investment *GrowthCount `json:"investment,omitempty"`
	Purchase *GrowthCount `json:"purchase,omitempty"`
	Referral *GrowthCount `json:"referral,omitempty"`
}

// NewActivitiesGrowthCount instantiates a new ActivitiesGrowthCount object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewActivitiesGrowthCount() *ActivitiesGrowthCount {
	this := ActivitiesGrowthCount{}
	return &this
}

// NewActivitiesGrowthCountWithDefaults instantiates a new ActivitiesGrowthCount object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewActivitiesGrowthCountWithDefaults() *ActivitiesGrowthCount {
	this := ActivitiesGrowthCount{}
	return &this
}

// GetMessengerMoment returns the MessengerMoment field value if set, zero value otherwise.
func (o *ActivitiesGrowthCount) GetMessengerMoment() GrowthCount {
	if o == nil || IsNil(o.MessengerMoment) {
		var ret GrowthCount
		return ret
	}
	return *o.MessengerMoment
}

// GetMessengerMomentOk returns a tuple with the MessengerMoment field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActivitiesGrowthCount) GetMessengerMomentOk() (*GrowthCount, bool) {
	if o == nil || IsNil(o.MessengerMoment) {
		return nil, false
	}
	return o.MessengerMoment, true
}

// HasMessengerMoment returns a boolean if a field has been set.
func (o *ActivitiesGrowthCount) HasMessengerMoment() bool {
	if o != nil && !IsNil(o.MessengerMoment) {
		return true
	}

	return false
}

// SetMessengerMoment gets a reference to the given GrowthCount and assigns it to the MessengerMoment field.
func (o *ActivitiesGrowthCount) SetMessengerMoment(v GrowthCount) {
	o.MessengerMoment = &v
}

// GetVisit returns the Visit field value if set, zero value otherwise.
func (o *ActivitiesGrowthCount) GetVisit() GrowthCount {
	if o == nil || IsNil(o.Visit) {
		var ret GrowthCount
		return ret
	}
	return *o.Visit
}

// GetVisitOk returns a tuple with the Visit field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActivitiesGrowthCount) GetVisitOk() (*GrowthCount, bool) {
	if o == nil || IsNil(o.Visit) {
		return nil, false
	}
	return o.Visit, true
}

// HasVisit returns a boolean if a field has been set.
func (o *ActivitiesGrowthCount) HasVisit() bool {
	if o != nil && !IsNil(o.Visit) {
		return true
	}

	return false
}

// SetVisit gets a reference to the given GrowthCount and assigns it to the Visit field.
func (o *ActivitiesGrowthCount) SetVisit(v GrowthCount) {
	o.Visit = &v
}

// GetInvestment returns the Investment field value if set, zero value otherwise.
func (o *ActivitiesGrowthCount) GetInvestment() GrowthCount {
	if o == nil || IsNil(o.Investment) {
		var ret GrowthCount
		return ret
	}
	return *o.Investment
}

// GetInvestmentOk returns a tuple with the Investment field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActivitiesGrowthCount) GetInvestmentOk() (*GrowthCount, bool) {
	if o == nil || IsNil(o.Investment) {
		return nil, false
	}
	return o.Investment, true
}

// HasInvestment returns a boolean if a field has been set.
func (o *ActivitiesGrowthCount) HasInvestment() bool {
	if o != nil && !IsNil(o.Investment) {
		return true
	}

	return false
}

// SetInvestment gets a reference to the given GrowthCount and assigns it to the Investment field.
func (o *ActivitiesGrowthCount) SetInvestment(v GrowthCount) {
	o.Investment = &v
}

// GetPurchase returns the Purchase field value if set, zero value otherwise.
func (o *ActivitiesGrowthCount) GetPurchase() GrowthCount {
	if o == nil || IsNil(o.Purchase) {
		var ret GrowthCount
		return ret
	}
	return *o.Purchase
}

// GetPurchaseOk returns a tuple with the Purchase field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActivitiesGrowthCount) GetPurchaseOk() (*GrowthCount, bool) {
	if o == nil || IsNil(o.Purchase) {
		return nil, false
	}
	return o.Purchase, true
}

// HasPurchase returns a boolean if a field has been set.
func (o *ActivitiesGrowthCount) HasPurchase() bool {
	if o != nil && !IsNil(o.Purchase) {
		return true
	}

	return false
}

// SetPurchase gets a reference to the given GrowthCount and assigns it to the Purchase field.
func (o *ActivitiesGrowthCount) SetPurchase(v GrowthCount) {
	o.Purchase = &v
}

// GetReferral returns the Referral field value if set, zero value otherwise.
func (o *ActivitiesGrowthCount) GetReferral() GrowthCount {
	if o == nil || IsNil(o.Referral) {
		var ret GrowthCount
		return ret
	}
	return *o.Referral
}

// GetReferralOk returns a tuple with the Referral field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActivitiesGrowthCount) GetReferralOk() (*GrowthCount, bool) {
	if o == nil || IsNil(o.Referral) {
		return nil, false
	}
	return o.Referral, true
}

// HasReferral returns a boolean if a field has been set.
func (o *ActivitiesGrowthCount) HasReferral() bool {
	if o != nil && !IsNil(o.Referral) {
		return true
	}

	return false
}

// SetReferral gets a reference to the given GrowthCount and assigns it to the Referral field.
func (o *ActivitiesGrowthCount) SetReferral(v GrowthCount) {
	o.Referral = &v
}

func (o ActivitiesGrowthCount) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ActivitiesGrowthCount) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.MessengerMoment) {
		toSerialize["messengerMoment"] = o.MessengerMoment
	}
	if !IsNil(o.Visit) {
		toSerialize["visit"] = o.Visit
	}
	if !IsNil(o.Investment) {
		toSerialize["investment"] = o.Investment
	}
	if !IsNil(o.Purchase) {
		toSerialize["purchase"] = o.Purchase
	}
	if !IsNil(o.Referral) {
		toSerialize["referral"] = o.Referral
	}
	return toSerialize, nil
}

type NullableActivitiesGrowthCount struct {
	value *ActivitiesGrowthCount
	isSet bool
}

func (v NullableActivitiesGrowthCount) Get() *ActivitiesGrowthCount {
	return v.value
}

func (v *NullableActivitiesGrowthCount) Set(val *ActivitiesGrowthCount) {
	v.value = val
	v.isSet = true
}

func (v NullableActivitiesGrowthCount) IsSet() bool {
	return v.isSet
}

func (v *NullableActivitiesGrowthCount) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableActivitiesGrowthCount(val *ActivitiesGrowthCount) *NullableActivitiesGrowthCount {
	return &NullableActivitiesGrowthCount{value: val, isSet: true}
}

func (v NullableActivitiesGrowthCount) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableActivitiesGrowthCount) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


